# HG changeset patch
# User Stefano Guidoni <ilguido@users.sf.net>
# Date 1609859571 -3600
#      Tue Jan 05 16:12:51 2021 +0100
# Node ID f52e33c9626b5542fdea0eff2faa5dbcc61ec07c
# Parent  cf75916fb51c53b57d94622300c187a090eade56
update dataset: fisheriris

diff --git a/inst/fisheriris.mat b/inst/fisheriris.mat
new file mode 100644
--- /dev/null
+++ b/inst/fisheriris.mat
@@ -0,0 +1,1214 @@
+# Reference: UCI Machine Learning Repository [http://archive.ics.uci.edu/ml]
+# name: meas
+# type: matrix
+# rows: 150
+# columns: 4
+ 5.1 3.5 1.4 0.2
+ 4.9 3 1.4 0.2
+ 4.7 3.2 1.3 0.2
+ 4.6 3.1 1.5 0.2
+ 5 3.6 1.4 0.2
+ 5.4 3.9 1.7 0.4
+ 4.6 3.4 1.4 0.3
+ 5 3.4 1.5 0.2
+ 4.4 2.9 1.4 0.2
+ 4.9 3.1 1.5 0.1
+ 5.4 3.7 1.5 0.2
+ 4.8 3.4 1.6 0.2
+ 4.8 3 1.4 0.1
+ 4.3 3 1.1 0.1
+ 5.8 4 1.2 0.2
+ 5.7 4.4 1.5 0.4
+ 5.4 3.9 1.3 0.4
+ 5.1 3.5 1.4 0.3
+ 5.7 3.8 1.7 0.3
+ 5.1 3.8 1.5 0.3
+ 5.4 3.4 1.7 0.2
+ 5.1 3.7 1.5 0.4
+ 4.6 3.6 1 0.2
+ 5.1 3.3 1.7 0.5
+ 4.8 3.4 1.9 0.2
+ 5 3 1.6 0.2
+ 5 3.4 1.6 0.4
+ 5.2 3.5 1.5 0.2
+ 5.2 3.4 1.4 0.2
+ 4.7 3.2 1.6 0.2
+ 4.8 3.1 1.6 0.2
+ 5.4 3.4 1.5 0.4
+ 5.2 4.1 1.5 0.1
+ 5.5 4.2 1.4 0.2
+ 4.9 3.1 1.5 0.2
+ 5 3.2 1.2 0.2
+ 5.5 3.5 1.3 0.2
+ 4.9 3.6 1.4 0.1
+ 4.4 3 1.3 0.2
+ 5.1 3.4 1.5 0.2
+ 5 3.5 1.3 0.3
+ 4.5 2.3 1.3 0.3
+ 4.4 3.2 1.3 0.2
+ 5 3.5 1.6 0.6
+ 5.1 3.8 1.9 0.4
+ 4.8 3 1.4 0.3
+ 5.1 3.8 1.6 0.2
+ 4.6 3.2 1.4 0.2
+ 5.3 3.7 1.5 0.2
+ 5 3.3 1.4 0.2
+ 7 3.2 4.7 1.4
+ 6.4 3.2 4.5 1.5
+ 6.9 3.1 4.9 1.5
+ 5.5 2.3 4 1.3
+ 6.5 2.8 4.6 1.5
+ 5.7 2.8 4.5 1.3
+ 6.3 3.3 4.7 1.6
+ 4.9 2.4 3.3 1
+ 6.6 2.9 4.6 1.3
+ 5.2 2.7 3.9 1.4
+ 5 2 3.5 1
+ 5.9 3 4.2 1.5
+ 6 2.2 4 1
+ 6.1 2.9 4.7 1.4
+ 5.6 2.9 3.6 1.3
+ 6.7 3.1 4.4 1.4
+ 5.6 3 4.5 1.5
+ 5.8 2.7 4.1 1
+ 6.2 2.2 4.5 1.5
+ 5.6 2.5 3.9 1.1
+ 5.9 3.2 4.8 1.8
+ 6.1 2.8 4 1.3
+ 6.3 2.5 4.9 1.5
+ 6.1 2.8 4.7 1.2
+ 6.4 2.9 4.3 1.3
+ 6.6 3 4.4 1.4
+ 6.8 2.8 4.8 1.4
+ 6.7 3 5 1.7
+ 6 2.9 4.5 1.5
+ 5.7 2.6 3.5 1
+ 5.5 2.4 3.8 1.1
+ 5.5 2.4 3.7 1
+ 5.8 2.7 3.9 1.2
+ 6 2.7 5.1 1.6
+ 5.4 3 4.5 1.5
+ 6 3.4 4.5 1.6
+ 6.7 3.1 4.7 1.5
+ 6.3 2.3 4.4 1.3
+ 5.6 3 4.1 1.3
+ 5.5 2.5 4 1.3
+ 5.5 2.6 4.4 1.2
+ 6.1 3 4.6 1.4
+ 5.8 2.6 4 1.2
+ 5 2.3 3.3 1
+ 5.6 2.7 4.2 1.3
+ 5.7 3 4.2 1.2
+ 5.7 2.9 4.2 1.3
+ 6.2 2.9 4.3 1.3
+ 5.1 2.5 3 1.1
+ 5.7 2.8 4.1 1.3
+ 6.3 3.3 6 2.5
+ 5.8 2.7 5.1 1.9
+ 7.1 3 5.9 2.1
+ 6.3 2.9 5.6 1.8
+ 6.5 3 5.8 2.2
+ 7.6 3 6.6 2.1
+ 4.9 2.5 4.5 1.7
+ 7.3 2.9 6.3 1.8
+ 6.7 2.5 5.8 1.8
+ 7.2 3.6 6.1 2.5
+ 6.5 3.2 5.1 2
+ 6.4 2.7 5.3 1.9
+ 6.8 3 5.5 2.1
+ 5.7 2.5 5 2
+ 5.8 2.8 5.1 2.4
+ 6.4 3.2 5.3 2.3
+ 6.5 3 5.5 1.8
+ 7.7 3.8 6.7 2.2
+ 7.7 2.6 6.9 2.3
+ 6 2.2 5 1.5
+ 6.9 3.2 5.7 2.3
+ 5.6 2.8 4.9 2
+ 7.7 2.8 6.7 2
+ 6.3 2.7 4.9 1.8
+ 6.7 3.3 5.7 2.1
+ 7.2 3.2 6 1.8
+ 6.2 2.8 4.8 1.8
+ 6.1 3 4.9 1.8
+ 6.4 2.8 5.6 2.1
+ 7.2 3 5.8 1.6
+ 7.4 2.8 6.1 1.9
+ 7.9 3.8 6.4 2
+ 6.4 2.8 5.6 2.2
+ 6.3 2.8 5.1 1.5
+ 6.1 2.6 5.6 1.4
+ 7.7 3 6.1 2.3
+ 6.3 3.4 5.6 2.4
+ 6.4 3.1 5.5 1.8
+ 6 3 4.8 1.8
+ 6.9 3.1 5.4 2.1
+ 6.7 3.1 5.6 2.4
+ 6.9 3.1 5.1 2.3
+ 5.8 2.7 5.1 1.9
+ 6.8 3.2 5.9 2.3
+ 6.7 3.3 5.7 2.5
+ 6.7 3 5.2 2.3
+ 6.3 2.5 5 1.9
+ 6.5 3 5.2 2
+ 6.2 3.4 5.4 2.3
+ 5.9 3 5.1 1.8
+
+
+# name: species
+# type: cell
+# rows: 150
+# columns: 1
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+
+
+
diff --git a/inst/fisheriris.txt b/inst/fisheriris.txt
deleted file mode 100644
--- a/inst/fisheriris.txt
+++ /dev/null
@@ -1,153 +0,0 @@
-#Fisher iris data set
-#cf. https://en.wikipedia.org/wiki/Iris_flower_data_set
-#Type	PW	PL	SW	SL
-0	2	14	33	50
-1	24	56	31	67
-1	23	51	31	69
-0	2	10	36	46
-1	20	52	30	65
-1	19	51	27	58
-2	13	45	28	57
-2	16	47	33	63
-1	17	45	25	49
-2	14	47	32	70
-0	2	16	31	48
-1	19	50	25	63
-0	1	14	36	49
-0	2	13	32	44
-2	12	40	26	58
-1	18	49	27	63
-2	10	33	23	50
-0	2	16	38	51
-0	2	16	30	50
-1	21	56	28	64
-0	4	19	38	51
-0	2	14	30	49
-2	10	41	27	58
-2	15	45	29	60
-0	2	14	36	50
-1	19	51	27	58
-0	4	15	34	54
-1	18	55	31	64
-2	10	33	24	49
-0	2	14	42	55
-1	15	50	22	60
-2	14	39	27	52
-0	2	14	29	44
-2	12	39	27	58
-1	23	57	32	69
-2	15	42	30	59
-1	20	49	28	56
-1	18	58	25	67
-2	13	44	23	63
-2	15	49	25	63
-2	11	30	25	51
-1	21	54	31	69
-1	25	61	36	72
-2	13	36	29	56
-1	21	55	30	68
-0	1	14	30	48
-0	3	17	38	57
-2	14	44	30	66
-0	4	15	37	51
-2	17	50	30	67
-1	22	56	28	64
-1	15	51	28	63
-2	15	45	22	62
-2	14	46	30	61
-2	11	39	25	56
-1	23	59	32	68
-1	23	54	34	62
-1	25	57	33	67
-0	2	13	35	55
-2	15	45	32	64
-1	18	51	30	59
-1	23	53	32	64
-2	15	45	30	54
-1	21	57	33	67
-0	2	13	30	44
-0	2	16	32	47
-1	18	60	32	72
-1	18	49	30	61
-0	2	12	32	50
-0	1	11	30	43
-2	14	44	31	67
-0	2	14	35	51
-0	4	16	34	50
-2	10	35	26	57
-1	23	61	30	77
-2	13	42	26	57
-0	1	15	41	52
-1	18	48	30	60
-2	13	42	27	56
-0	2	15	31	49
-0	4	17	39	54
-2	16	45	34	60
-2	10	35	20	50
-0	2	13	32	47
-2	13	54	29	62
-0	2	15	34	51
-2	10	50	22	60
-0	1	15	31	49
-0	2	15	37	54
-2	12	47	28	61
-2	13	41	28	57
-0	4	13	39	54
-1	20	51	32	65
-2	15	49	31	69
-2	13	40	25	55
-0	3	13	23	45
-0	3	15	38	51
-2	14	48	28	68
-0	2	15	35	52
-1	25	60	33	63
-2	15	46	28	65
-0	3	14	34	46
-2	18	48	32	59
-2	16	51	27	60
-1	18	55	30	65
-0	5	17	33	51
-1	22	67	38	77
-1	21	66	30	76
-1	13	52	30	67
-2	13	40	28	61
-2	11	38	24	55
-0	2	14	34	52
-1	20	64	38	79
-0	6	16	35	50
-1	20	67	28	77
-2	12	44	26	55
-0	3	14	30	48
-0	2	19	34	48
-1	14	56	26	61
-0	2	12	40	58
-1	18	48	28	62
-2	15	45	30	56
-0	2	14	32	46
-0	4	15	44	57
-1	24	56	34	63
-1	16	58	30	72
-1	21	59	30	71
-1	18	56	29	63
-2	12	42	30	57
-1	23	69	26	77
-2	13	56	29	66
-0	2	15	34	52
-2	10	37	24	55
-0	2	15	31	46
-1	19	61	28	74
-0	3	13	35	50
-1	18	63	29	73
-2	15	47	31	67
-2	13	41	30	56
-2	13	43	29	64
-1	22	58	30	65
-0	3	14	35	51
-2	14	47	29	61
-1	19	53	27	64
-0	2	16	34	48
-1	20	50	25	57
-2	13	40	23	55
-0	2	17	34	54
-1	24	51	28	58
-0	2	15	37	53