# HG changeset patch
# User Stefano Guidoni <ilguido@users.sf.net>
# Date 1609684373 -3600
#      Sun Jan 03 15:32:53 2021 +0100
# Node ID f8d1e759bfc04cc91fd15de8dc499d31ebafe1fb
# Parent  b76c9b11f73c45fd5b6e8c59e7db7cd9340aa6db
new dataset: fisheriris

diff -r b76c9b11f73c -r f8d1e759bfc0 inst/fisheriris.mat
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/inst/fisheriris.mat	Sun Jan 03 15:32:53 2021 +0100
@@ -0,0 +1,1214 @@
+# Created by Octave 4.2.1
+# name: meas
+# type: matrix
+# rows: 150
+# columns: 4
+ 5.1 3.5 1.4 0.2
+ 4.9 3 1.4 0.2
+ 4.7 3.2 1.3 0.2
+ 4.6 3.1 1.5 0.2
+ 5 3.6 1.4 0.2
+ 5.4 3.9 1.7 0.4
+ 4.6 3.4 1.4 0.3
+ 5 3.4 1.5 0.2
+ 4.4 2.9 1.4 0.2
+ 4.9 3.1 1.5 0.1
+ 5.4 3.7 1.5 0.2
+ 4.8 3.4 1.6 0.2
+ 4.8 3 1.4 0.1
+ 4.3 3 1.1 0.1
+ 5.8 4 1.2 0.2
+ 5.7 4.4 1.5 0.4
+ 5.4 3.9 1.3 0.4
+ 5.1 3.5 1.4 0.3
+ 5.7 3.8 1.7 0.3
+ 5.1 3.8 1.5 0.3
+ 5.4 3.4 1.7 0.2
+ 5.1 3.7 1.5 0.4
+ 4.6 3.6 1 0.2
+ 5.1 3.3 1.7 0.5
+ 4.8 3.4 1.9 0.2
+ 5 3 1.6 0.2
+ 5 3.4 1.6 0.4
+ 5.2 3.5 1.5 0.2
+ 5.2 3.4 1.4 0.2
+ 4.7 3.2 1.6 0.2
+ 4.8 3.1 1.6 0.2
+ 5.4 3.4 1.5 0.4
+ 5.2 4.1 1.5 0.1
+ 5.5 4.2 1.4 0.2
+ 4.9 3.1 1.5 0.2
+ 5 3.2 1.2 0.2
+ 5.5 3.5 1.3 0.2
+ 4.9 3.6 1.4 0.1
+ 4.4 3 1.3 0.2
+ 5.1 3.4 1.5 0.2
+ 5 3.5 1.3 0.3
+ 4.5 2.3 1.3 0.3
+ 4.4 3.2 1.3 0.2
+ 5 3.5 1.6 0.6
+ 5.1 3.8 1.9 0.4
+ 4.8 3 1.4 0.3
+ 5.1 3.8 1.6 0.2
+ 4.6 3.2 1.4 0.2
+ 5.3 3.7 1.5 0.2
+ 5 3.3 1.4 0.2
+ 7 3.2 4.7 1.4
+ 6.4 3.2 4.5 1.5
+ 6.9 3.1 4.9 1.5
+ 5.5 2.3 4 1.3
+ 6.5 2.8 4.6 1.5
+ 5.7 2.8 4.5 1.3
+ 6.3 3.3 4.7 1.6
+ 4.9 2.4 3.3 1
+ 6.6 2.9 4.6 1.3
+ 5.2 2.7 3.9 1.4
+ 5 2 3.5 1
+ 5.9 3 4.2 1.5
+ 6 2.2 4 1
+ 6.1 2.9 4.7 1.4
+ 5.6 2.9 3.6 1.3
+ 6.7 3.1 4.4 1.4
+ 5.6 3 4.5 1.5
+ 5.8 2.7 4.1 1
+ 6.2 2.2 4.5 1.5
+ 5.6 2.5 3.9 1.1
+ 5.9 3.2 4.8 1.8
+ 6.1 2.8 4 1.3
+ 6.3 2.5 4.9 1.5
+ 6.1 2.8 4.7 1.2
+ 6.4 2.9 4.3 1.3
+ 6.6 3 4.4 1.4
+ 6.8 2.8 4.8 1.4
+ 6.7 3 5 1.7
+ 6 2.9 4.5 1.5
+ 5.7 2.6 3.5 1
+ 5.5 2.4 3.8 1.1
+ 5.5 2.4 3.7 1
+ 5.8 2.7 3.9 1.2
+ 6 2.7 5.1 1.6
+ 5.4 3 4.5 1.5
+ 6 3.4 4.5 1.6
+ 6.7 3.1 4.7 1.5
+ 6.3 2.3 4.4 1.3
+ 5.6 3 4.1 1.3
+ 5.5 2.5 4 1.3
+ 5.5 2.6 4.4 1.2
+ 6.1 3 4.6 1.4
+ 5.8 2.6 4 1.2
+ 5 2.3 3.3 1
+ 5.6 2.7 4.2 1.3
+ 5.7 3 4.2 1.2
+ 5.7 2.9 4.2 1.3
+ 6.2 2.9 4.3 1.3
+ 5.1 2.5 3 1.1
+ 5.7 2.8 4.1 1.3
+ 6.3 3.3 6 2.5
+ 5.8 2.7 5.1 1.9
+ 7.1 3 5.9 2.1
+ 6.3 2.9 5.6 1.8
+ 6.5 3 5.8 2.2
+ 7.6 3 6.6 2.1
+ 4.9 2.5 4.5 1.7
+ 7.3 2.9 6.3 1.8
+ 6.7 2.5 5.8 1.8
+ 7.2 3.6 6.1 2.5
+ 6.5 3.2 5.1 2
+ 6.4 2.7 5.3 1.9
+ 6.8 3 5.5 2.1
+ 5.7 2.5 5 2
+ 5.8 2.8 5.1 2.4
+ 6.4 3.2 5.3 2.3
+ 6.5 3 5.5 1.8
+ 7.7 3.8 6.7 2.2
+ 7.7 2.6 6.9 2.3
+ 6 2.2 5 1.5
+ 6.9 3.2 5.7 2.3
+ 5.6 2.8 4.9 2
+ 7.7 2.8 6.7 2
+ 6.3 2.7 4.9 1.8
+ 6.7 3.3 5.7 2.1
+ 7.2 3.2 6 1.8
+ 6.2 2.8 4.8 1.8
+ 6.1 3 4.9 1.8
+ 6.4 2.8 5.6 2.1
+ 7.2 3 5.8 1.6
+ 7.4 2.8 6.1 1.9
+ 7.9 3.8 6.4 2
+ 6.4 2.8 5.6 2.2
+ 6.3 2.8 5.1 1.5
+ 6.1 2.6 5.6 1.4
+ 7.7 3 6.1 2.3
+ 6.3 3.4 5.6 2.4
+ 6.4 3.1 5.5 1.8
+ 6 3 4.8 1.8
+ 6.9 3.1 5.4 2.1
+ 6.7 3.1 5.6 2.4
+ 6.9 3.1 5.1 2.3
+ 5.8 2.7 5.1 1.9
+ 6.8 3.2 5.9 2.3
+ 6.7 3.3 5.7 2.5
+ 6.7 3 5.2 2.3
+ 6.3 2.5 5 1.9
+ 6.5 3 5.2 2
+ 6.2 3.4 5.4 2.3
+ 5.9 3 5.1 1.8
+
+
+# name: species
+# type: cell
+# rows: 150
+# columns: 1
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 6
+setosa
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 10
+versicolor
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+# name: <cell-element>
+# type: string
+# elements: 1
+# length: 9
+virginica
+
+
+
+
+